> ## Documentation Index
> Fetch the complete documentation index at: https://docs.haiqu.ai/llms.txt
> Use this file to discover all available pages before exploring further.

# Transpile Circuit

> Transpile a circuit to a given device.

Args:
    user (User): User authenticated with api key.
    data (SubmitTranspilationModel): Transpilation options.
    db (Session): The database session.

Returns:
    TranspilationJobModel: The new job object.



## OpenAPI

````yaml https://api.haiqu.ai/openapi.json post /circuits/transpile
openapi: 3.1.0
info:
  title: Haiqu API
  summary: Haiqu RESTful API service.
  description: Cloud service providing the access to Haiqu cloud runtime
  contact:
    name: Haiqu Inc.
    url: https://haiqu.ai/
    email: info@haiqu.ai
  version: 1.4.0
servers: []
security: []
paths:
  /circuits/transpile:
    post:
      summary: Transpile Circuit
      description: |-
        Transpile a circuit to a given device.

        Args:
            user (User): User authenticated with api key.
            data (SubmitTranspilationModel): Transpilation options.
            db (Session): The database session.

        Returns:
            TranspilationJobModel: The new job object.
      operationId: transpile_circuit_circuits_transpile_post
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/SubmitTranspilationModel'
        required: true
      responses:
        '200':
          description: Successful Response
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/TranspilationJobModel'
        '422':
          description: Validation Error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/HTTPValidationError'
      security:
        - APIKeyQuery: []
        - APIKeyHeader: []
components:
  schemas:
    SubmitTranspilationModel:
      properties:
        experiment_id:
          type: string
          title: Experiment Id
        circuit_ids:
          items: {}
          type: array
          title: Circuit Ids
          default: []
        device_id:
          type: string
          title: Device Id
        transpilation_options:
          anyOf:
            - additionalProperties: true
              type: object
            - type: 'null'
          title: Transpilation Options
          default: {}
        name:
          anyOf:
            - type: string
            - type: 'null'
          title: Name
          default: ''
        description:
          anyOf:
            - type: string
            - type: 'null'
          title: Description
          default: ''
      type: object
      required:
        - experiment_id
        - device_id
      title: SubmitTranspilationModel
      description: Data model for transpilation submit request
    TranspilationJobModel:
      properties:
        id:
          type: string
          title: Id
        name:
          anyOf:
            - type: string
            - type: 'null'
          title: Name
        description:
          anyOf:
            - type: string
            - type: 'null'
          title: Description
        user_id:
          type: integer
          title: User Id
        experiment_id:
          type: string
          title: Experiment Id
        status:
          $ref: '#/components/schemas/JobStatus'
        job_type:
          $ref: '#/components/schemas/JobType'
        device_id:
          type: string
          title: Device Id
        creation_date:
          type: string
          format: date-time
          title: Creation Date
        run_date:
          anyOf:
            - type: string
              format: date-time
            - type: 'null'
          title: Run Date
        finish_date:
          anyOf:
            - type: string
              format: date-time
            - type: 'null'
          title: Finish Date
        logs:
          anyOf:
            - type: string
            - type: 'null'
          title: Logs
        quality:
          anyOf:
            - type: number
            - type: 'null'
          title: Quality
        info:
          anyOf:
            - additionalProperties: true
              type: object
            - type: 'null'
          title: Info
        time:
          anyOf:
            - type: number
            - type: 'null'
          title: Time
        parameters:
          anyOf:
            - additionalProperties: true
              type: object
            - items: {}
              type: array
            - type: 'null'
          title: Parameters
        circuit_ids:
          items: {}
          type: array
          title: Circuit Ids
        transpilation_options:
          additionalProperties: true
          type: object
          title: Transpilation Options
        transpiled_circuit_ids:
          anyOf:
            - items: {}
              type: array
            - type: 'null'
          title: Transpiled Circuit Ids
      type: object
      required:
        - id
        - user_id
        - experiment_id
        - status
        - job_type
        - device_id
        - creation_date
        - circuit_ids
        - transpilation_options
      title: TranspilationJobModel
      description: Job model for transpilation jobs.
    HTTPValidationError:
      properties:
        detail:
          items:
            $ref: '#/components/schemas/ValidationError'
          type: array
          title: Detail
      type: object
      title: HTTPValidationError
    JobStatus:
      type: string
      enum:
        - Submitted
        - Initializing
        - Queued
        - Validating
        - Running
        - Cancelled
        - Done
        - Error
      title: JobStatus
      description: Class for job status.
    JobType:
      type: string
      enum:
        - User local job
        - Analytics
        - Device specific analytics
        - Data Loading
        - Hybrid
        - Run
        - State Compression
        - Transpilation
        - Variational
        - Pretraining
        - SKQD
      title: JobType
      description: Class for job types.
    ValidationError:
      properties:
        loc:
          items:
            anyOf:
              - type: string
              - type: integer
          type: array
          title: Location
        msg:
          type: string
          title: Message
        type:
          type: string
          title: Error Type
      type: object
      required:
        - loc
        - msg
        - type
      title: ValidationError
  securitySchemes:
    APIKeyQuery:
      type: apiKey
      in: query
      name: HAIQU_API_KEY
    APIKeyHeader:
      type: apiKey
      in: header
      name: authorization

````